
public class IntegrationTrapeze {
    /**
     * Intgration par la mthode des trapzes
     * 
     * @param n nombre de sous-intervalles
     * @param a borne infrieure d'intgration
     * @param b borne suprieure d'intgration
     * @param f fonction a intgrer
     * @return intgrale de la fonction f sur l'intervalle [a, b]
     */
    public static double integre(int n, double a, double b, FonctionDUneVariable f)
    {
        double deltaX = (b - a)/n;
        double x = a; 
        double somme = 0;
        
        if (f.estDefinie(a) && f.estDefinie(b))
            somme = (f.calculFonctionEn(a) + f.calculFonctionEn(b)) / 2.;
        else throw new ArithmeticException("Fonction non dfinie");
        
        for(int i=1; i < n; i++)
        {
            x += deltaX;
            if (f.estDefinie(x))
                somme += f.calculFonctionEn(x);
            else throw new ArithmeticException("Fonction non dfinie");
        }
        return somme * deltaX;
    }
}

